import  java.io.*;
import  java.util.Scanner;

public class Heapify {

    public static void printIndexes(int a[]) {
	int i;
	System.out.printf("\n-");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",i+1);
	System.out.printf("--\n\n");
    }

        
    public static void printArray(int a[]) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	    System.out.printf("%2d ",a[i]);
	System.out.printf("]\n");
    }

    public static void printSubArray(int a[], int l, int r) {
	int i;
	System.out.printf("[");
	for(i = 0; i < a.length; i++)
	  if (i>=l && i <= r)
	    System.out.printf("%2d ",a[i]);
          else
	    System.out.printf("   ");
	System.out.printf("]\n");
    }

  public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
  } 

    public static void heapify(int a[], int i, int n) {
	int l = 2*(i+1)-1, r = 2*(i+1), m = i;
	if(l <= n && a[l] > a[m]) m = l;
	if(r <= n && a[r] > a[m]) m = r;
	if(i != m) {
	    int t = a[i]; 
            a[i] = a[m];
	    a[m] = t; 
            heapify(a,m,n);
	}
    } 

    public static void main(String args[]) {
        Scanner in = new Scanner(System.in);    
	int[] a = readArray();
        int index;
	printArray(a);
        do {
	  System.out.print("Index to heapify: 1.."+(a.length)+": ");
          index = in.nextInt();
printIndexes(a);
 	  heapify(a,index-1,a.length);
	  printArray(a);
	}  while  (index > 0 && index <= a.length);     
    }
}
